/*
 * This file is part of the Cforall project
 *
 * $Id: DeclarationWithType.cc,v 1.9 2005/08/29 20:59:25 rcbilson Exp $
 *
 */

#include "Declaration.h"
#include "Type.h"
#include "utility.h"


DeclarationWithType::DeclarationWithType( const std::string &name, StorageClass sc, LinkageSpec::Type linkage )
    : Declaration( name, sc, linkage )
{
}

DeclarationWithType::DeclarationWithType( const DeclarationWithType &other )
    : Declaration( other ), mangleName( other.mangleName )
{
}

DeclarationWithType::~DeclarationWithType()
{
}

