/*
 * This file is part of the Cforall project
 *
 * $Id: VoidType.cc,v 1.3 2005/08/29 20:59:27 rcbilson Exp $
 *
 */

#include "Type.h"


VoidType::VoidType( const Type::Qualifiers &tq )
    : Type( tq )
{
}

void
VoidType::print( std::ostream &os, int indent ) const
{
    Type::print( os, indent );
    os << "void ";
}

